/*============================================================================
  File:     UsingHierarchyIDWithSQLCLR.sql

  Summary:  Deployment and test script for SQLCLR project HierarchyProj
  
			NOTE: You must run the script PopulateHierarchy.sql in the 
			3-Beyond directory to be able to run the tests in this script.
  
			NOTE: You can deploy the assembly and functions using Visual Studio 
			autodeploy, or use this script and manual assembly and UDF 
			deployment. 
  
  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program. 
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

sp_configure 'show advanced options', 1
reconfigure
go
sp_configure 'clr enabled', 1
reconfigure

use AdventureWorks2008
go

-- This script requires the HumanResources.EmployeeOrg
-- If it does not exist, run the script
-- 3a. PopulateHierarchy.sql in this directory
-- SQLCLR code to list ancestors
-- fix path or point project build step to c:\temp
CREATE ASSEMBLY HierarchyId_Operations 
FROM 'C:\temp\HierarchyProj.dll'
GO

CREATE FUNCTION ListAncestors (@node hierarchyid)
RETURNS TABLE (node hierarchyid)
AS
EXTERNAL NAME HierarchyId_Operations.HierarchyId_Operations.ListAncestors
GO

DECLARE @h hierarchyid
SELECT @h = OrgNode 
FROM HumanResources.EmployeeOrg  
WHERE EmployeeID = 269       -- Wanida      

SELECT EmployeeID, EmpName, OrgNode.ToString() AS LogicalNode
FROM HumanResources.EmployeeOrg AS ED
JOIN ListAncestors(@h) AS A 
   ON ED.OrgNode = A.Node
GO

-- cleanup
drop function ListAncestors
drop assembly hierarchyid_operations
GO
