/*============================================================================
  File:     largeudagg.sql

  Summary:  Deployement and test script for the LargeUDagg projcect.
  
			NOTE: Deploying large user-defined aggregates is not 
			supported by Visual Studio autodeploy. Use this script and manual
			assembly and function deployment.

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/
sp_configure 'show advanced options', 1
reconfigure
go
sp_configure 'clr enabled', 1
reconfigure

if DATABASEPROPERTY('test', 'Version') is null
create database test
go

use test
go

create assembly largeudagg 
from 'C:\temp\LargeUDAgg.dll'
go

create aggregate concatenate(@input1 nvarchar(max))
returns nvarchar(max)
external name largeudagg.Concatenate;
go

create table testtab (
 id int primary key identity,
 col1 varchar(max)
)
go
 
declare @a nvarchar(max) = replicate(convert(nvarchar(max), 'a'),10000)
insert testtab values(@a)
insert testtab values(@a)
go


select dbo.concatenate(col1) as [value],  
       LEN(dbo.concatenate(col1)) as [length]
from testtab

