/*============================================================================
  File:     NullableTypes.sql

  Summary:  This script is a setup and test script for the SQLCLR assembly
			Nullable. It illustrates the use of .NET Nullable types in
			a SQLCLR procedures, functions, etc.
			
			NOTE: Deploying function that use nullable types as parameters is 
			not supported by Visual Studio autodeploy. Use this script and 
			manual assembly and function deployment.

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

sp_configure 'show advanced options', 1
reconfigure
go
sp_configure 'clr enabled', 1
reconfigure

if DATABASEPROPERTY('test', 'Version') is null
create database test
go

create assembly n1 from 'c:\temp\nullabletypes.dll'
go

create function addtwo (@a int, @b int)
returns int
as
external name n1.[NullableTypes.Class1].AddTwo
go

select dbo.addtwo(1,null)