/*============================================================================
  File:     mondial_queries.sql

  Summary:  Demonstrates a spatial query against the geography column in the 
			Mondial database. You must run "mondial_latlong.sql" to define the
			geography column before running this script.

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/
use mondial
go

-- spatial queries

select geog.Lat, geog.Long, Latitude, Longitude, geog.STSrid
from city
where geog is not null

select c.Name, m.Name [Mountain Name], 
       c.geog.STDistance(m.geog)/1000 [Distance in km]
from city c, mountain m
where c.geog is not null
and c.Name = 'Portland'
order by c.geog.STDistance(m.geog)


